#include "verbimorfo.hh"
#include "nominimorfo.hh"
#include "argh.hh"

#include <string>
#include <cstdio>
using std::string;
using std::printf;
using std::fprintf;

int main(int argc, const char *const *argv)
{
	bool nega = false;
	string pers = "pas";
	string aika = "preesens";
	string dest = "pos";
	string sija = "nom";
	bool monikko = false;
	bool passiivi = false;
	
	ParamHandler Argh;
    Argh.AddLong("help",    'h').SetBool().SetDesc("This help.");
    Argh.AddLong("version", 'V').SetBool().SetDesc("Displays version information.");
	Argh.AddLong("pers", 'p').SetString().SetDesc("Valitse persoonamuoto (yks1,yks2,yks3,mon1,mon2,mon3,pass)", "<muoto>");
	Argh.AddLong("nega", 'n').SetBool().SetDesc("Valitse negaatio");
	Argh.AddLong("moni", 'l').SetBool().SetDesc("Valitse monikko");
	Argh.AddLong("pass", 'a').SetBool().SetDesc("Valitse passiivi (partisiippien ja III infinitiivin taivutukseen)");
	Argh.AddLong("aika", 't').SetString().SetDesc("Valitse aikamuoto (preesens,imperf,perf,pluskvamp)", "<aika>");
	Argh.AddLong("tapa", 'm').SetString().SetDesc("Valitse tapaluokka (ind,kond,pot,imp,1p,2p)", "<tapa>");
	Argh.AddLong("sija", 'j').SetString().SetDesc("Valitse sijamuoto", "<sija>");
	
	Argh.StartParse(argc, argv);
	bool sanoja = false;
	for(int c; (c=Argh.GetParam()) != -1; ++c)
	{
		switch(c)
		{
            case 'V': printf("%s\n", VERSION); return 0;
			case 'p': pers = Argh.GetString(); break;
			case 'n': nega = Argh.GetBool(); break;
			case 't': aika = Argh.GetString(); break;
			case 'm': dest = Argh.GetString(); break;
			case 'j': sija = Argh.GetString(); break;
			case 'l': monikko = Argh.GetBool(); break;
			case 'a': passiivi = Argh.GetBool(); break;
			case 'h':
				if(Argh.GetBool())
				{
					printf(
						"formodemo v"VERSION" - Copyright (C) 1992,2001 Bisqwit (http://iki.fi/bisqwit/)\n"
						"Thanks to Warp :)\n"
						"\n"
						"Usage: %s [<option> [<...>]] <word> [<...>]\n"
						"\n"
						"Options:\n", argv[0]);
					Argh.ListOptions();
					return 0;
				}
				break;
			default:
			{
				string word = Argh.GetString();
				
				string result;
				
				aikamuoto a;
				sijamuoto j;
				persoona p;
/* The following code has been generated by hashes from hashes.txt */
#include "mainhash.inc"
			}
		}
	}
	if(!sanoja)
		fprintf(stderr, "Sanaton!\nYrit %s --help\n", argv[0]);
	return 0;
}
